#include <errno.h>
#include <string.h>
#include <peekpoke.h>
#include <conio.h>
#include "gfx.h"
#include "diskio.h"


#define CURRDEV (*(unsigned char *)0xba)
#define SCREENLINE 8


static unsigned char get_device(void) {
    if (!CURRDEV) {
        CURRDEV = 8;
    }
    return CURRDEV;
}


static unsigned char *filetype[] = {
    "del",
    "seq",
    "prg",
    "usr",
    "rel",
    "cbm",
    "dir",
    "???",
    "vrp",
    "???"
};


void dir(void) {
    static struct cbm_dirent de;
    static char space17[] = "                  ";
    
    clrscr();
    if (cbm_opendir(1, CURRDEV)) {
        cputs(_stroserror(_oserror));
        goto done;
    }
    while (cbm_readdir(1, &de) == 0) {
        if (kbhit()) {
            if (cgetc() == 0x03) {
                break;
            }
        }
        if (wherey() > 24) {
            memcpy((unsigned char *)0x0400, (unsigned char *)0x0428, 960);
            memset((unsigned char *)0x07c0, 0x20, 40);
            memset((unsigned char *)0xdbc0, PEEK(646), 40);
            gotoxy(0, 24);
        }
        if (de.type == CBM_T_HEADER) {
            revers(1);
        } else {
            cprintf("%-5d", de.size);
        }
        cprintf("\"%s\"", de.name);
        if (de.type == CBM_T_HEADER) {
            cputs("\r\n");
            revers(0);
        } else {
            cputs(&space17[strlen(de.name)]);
            cprintf("%s\r\n", filetype[de.type]);
        }
    }
    cbm_closedir(1);

done:
    cgetc();
}


static char filename[17];

static unsigned char *get_filename(void) {
    unsigned char c, x;
    unsigned char len = 0;
    
    cputsxy(0, SCREENLINE, "Filename: ");
    
    for (;;) {
        cursor(1);
        c = cgetc();
        cursor(0);
        if (c == 0x0d) {
            if (len) {
                filename[len] = 0;
                return filename;
            } else {
                return NULL;
            }
        } else if (c == 0x03) {
            return NULL;
        } else if (c == 0x14) {
            if (len) {
                x = wherex() - 1;
                cputsxy(x, wherey(), " ");
                gotox(x);
                --len;
            }
        } else if (len < sizeof(filename) - 1){
            filename[len] = c;
            cputc(c);
            ++len;
        }
    }
}


static void copy_buf_to_image(void) {
    memcpy(screen, buf + sizeof(bitmap), sizeof(screen));
    memcpy(bitmap, buf, sizeof(bitmap));
}

static void copy_image_to_buf(void) {
    memcpy(buf, bitmap, sizeof(bitmap));
    memcpy(buf + sizeof(bitmap), screen, sizeof(screen));
}


void load(void) {
    char *filename;
    
    if ((filename = get_filename()) == NULL) {
        return;
    }
    cputsxy(0, SCREENLINE + 1, "Loading ");
    cputs(filename);
    
    if (cbm_load(filename, get_device(), buf) < 9000) {
        cputsxy(0, SCREENLINE + 2, _stroserror(_oserror));
    } else {
        cputsxy(0, SCREENLINE + 2, "OK");
    }
    
    copy_buf_to_image();
    
    cputs(" (SPACE)");
    while (cgetc() != ' ') {;}
}


void save(void) {
    char *filename;
    
    if ((filename = get_filename()) == NULL) {
        return;
    }
    
    copy_image_to_buf();
    
    cputsxy(0, SCREENLINE + 1, "Saving ");
    cputs(filename);
    
    if (cbm_save(filename, get_device(), buf, 9000)) {
        cputsxy(0, SCREENLINE + 2, _stroserror(_oserror));
    } else {
        cputsxy(0, SCREENLINE + 2, "OK");
    }
    
    copy_buf_to_image();
    
    cputs(" (SPACE)");
    while (cgetc() != ' ') {;}
}
